'""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""
'Script to create a System Restore point in Windows 10, 8, 7, Vista and XP
'... Auto Restore Point Script that can be used with Task Scheduler.
'Created on May 10 2008 - Revised on Oct 13, 2016
' 2008-2016 - Ramesh Srinivasan. http://www.winhelponline.com/blog
'""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""
i24hrsLimit = 1

If GetOS = "Windows XP" Or GetOS = "Windows Vista" Or GetOS = "Windows 7" Then
  		CreateSRP
End If

If GetOS = "Windows 8" Or GetOS = "Windows 10" Then
	Const HKEY_LOCAL_MACHINE = &H80000002
	strComputer = "."
	If i24hrsLimit = 0 then
	    Set oReg=GetObject("winmgmts:{impersonationLevel=impersonate}!\\" & strComputer & "\root\default:StdRegProv")
	    strKeyPath = "SOFTWARE\Microsoft\Windows NT\CurrentVersion\SystemRestore"
	    strValueName = "SystemRestorePointCreationFrequency"
	    oReg.SetDWORDValue HKEY_LOCAL_MACHINE,strKeyPath,strValueName, 0  
	    CreateSRP
	    oReg.DeleteValue HKEY_LOCAL_MACHINE, strKeyPath, strValueName
	Elseif i24hrsLimit = 1 then
		CreateSRP
	End if
End If

Sub CreateSRP
	Set SRP = getobject("winmgmts:\\.\root\default:Systemrestore")
	
	If GetOS = "Windows 10" Then
		sOut = SRP.createrestorepoint ("Manual Restore Point", 7, 100)
	Else
		sDesc = "Automatic Restore Point (using Script)"
		sOut = SRP.createrestorepoint (sDesc, 0, 100)
	End If
		
	If sOut <> 0 Then
		WScript.echo "Error " & sOut & _
		  ": Unable to create Restore Point."
	End If
End Sub

Function GetOS    
    Set objWMI = GetObject("winmgmts:{impersonationLevel=impersonate}!\\" & _
    	".\root\cimv2")
    Set colOS = objWMI.ExecQuery("Select * from Win32_OperatingSystem")
    For Each objOS in colOS
	strOSName = objOS.Caption
        If instr(strOSName, "Windows 7") Then
        	GetOS = "Windows 7"    
        ElseIf instr(strOSName, "Vista") Then
        	GetOS = "Windows Vista"
        ElseIf instr(strOSName, "Windows XP") Then
      		GetOS = "Windows XP"
	ElseIf instr(strOSName, "Windows 8") Then
      		GetOS = "Windows 8"
	ElseIf instr(strOSName, "Windows 10") Then
      		GetOS = "Windows 10"
        End If
	Next
End Function